;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Super Smash Bros. Life Display patch
;By Scepile3
;
;This is basically a life display patch that hails from SSB.
;It displays the life amount with a symbol until the life amount
;reaches 6. Then it displays the original life stuff. To edit
;the palletes, load the rom inside the status bar editor and
;cheange the pallete of the places this patch hit.
;
;Original routine hacks from ICB's MetroidHP patch (unless
;otherwise specified). Original preservation code and routine
;hacking for new routine is from:
;
;Original code from:
; LR Hook - Version 1.1
; By Smallhacker
; 
; Disables L/R and prepares them to be used for other stuff
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $008F49 ;Unused ROM address here
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

macro RATS_start(id)
db "STAR"
dw RATS_Endcode<id>-RATS_Startcode<id> 
dw RATS_Endcode<id>-RATS_Startcode<id>^#$FFFF 
RATS_Startcode<id>: 
endmacro

macro RATS_end(id)
RATS_Endcode<id>: 
endmacro

lorom
header

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
org $008F49;Hijack the status bar routine
	JSL NewRoutine
org $008E6F ; moves time
	LDA $0F31
	STA $0F26
	LDA $0F32
	STA $0F27
	LDA $0F33
	STA $0F28

org $008F55 ;disables original life counter display (I found this in all.log.....before I remembered about the health patch T_T)
	NOP #6
org $008FD2
	NOP #$03
org $008FEF ; moves Dragon Coins
	STA $0F0B,x

org $05CC1A	;Get rid of Mario at course clear since we use that for other GFX.
	db $FC,$2C,$FC,$2C,$FC,$2C,$FC,$2C,$FC,$2C

org $05CC61	;and do the same for Luigi (Though it's best to use this patch for one player)
	db $FC,$FC,$FC,$FC,$FC


org $382ED
%RATS_start(0)
	BRA NewRoutine

NormalLifeDisplay:    ;this entire code is from all.log (besides return code and PLX + PHX)
	LDA #$FC  ; \
	STA $0EFD ;  |
	STA $0EFE ;  | Puts empty spaces where the icons were
	STA $0EFF ;  |
	STA $0F00 ; /
	LDA.w $0DBE     ; \ If amount of lives is negative, 
	BMI CODE_008F49 ; / branch to $8F49 
	CMP.b #$62      ;\ If amount of lives is less than 98, 
	BCC CODE_008F49 ;/ branch to $8F49 
	LDA.b #$62      ; \ Set amount of lives to 98 
	STA.w $0DBE     ; /  
CODE_008F49:
	LDA.w $0DBE      ; \  
	INC A            ;  |Get amount of lives in decimal 
                         ;  |
	PHX		 ;  |
	LDX.b #$00       ;  | 
CODE_009047:             ;  |
	CMP.b #$0A       ;  | 
	BCC Return009050 ;  |Sets A to 10s of original A 
	SBC.b #$0A       ;  |Sets X to 1s of original A 
	INX              ;  | 
	BRA CODE_009047  ;  | 
Return009050:            ; /

	PHY
	TXY             ; \  
	BNE CODE_008F55 ;  |If 10s is 0, replace with 0
	LDX.b #$00      ; /
CODE_008F55:
	STX.w $0EFB ; \ Write lives to status bar 
	STA.w $0EFC ; /  

	PLY
	PLX
	LDA $0DBE
	INC A 
    RTL

NewRoutine:
	LDA #$FC  ;\
	STA $0F15 ; | Makes the original life counter empty.
	STA $0F16 ; |
	STA $0F17 ;/
	LDA #$15  ; \ Puts L in the top left corner of status bar
	STA $0EF9 ; /
	LDA #$26  ;\ Puts x next to L
	STA $0EFA ;/
	STA $0F0A ; - puts x next to timer icon
	STA $0F25 ; puts x next to coin icon
	LDA #$2E  ; \ puts timer icon next to timer
	STA $0F09 ; /
	LDA #$76  ;\ puts coin icon next to yoshi coin counter
	STA $0F24 ;/
	LDA $0DBE             ; \
	CMP #$05              ;  | Makes it display normal life counter if life amount passes 5
	BCS NormalLifeDisplay ; /
	PHX
	LDA $0DB3
	BNE Luigi
	LDA #$30 ; gets unused Mario icon
	BRA All
Luigi:
	LDA #$31 ; gets unused Luigi icon
All:
	STA $0EFB ; \
	STA $0EFC ;  |puts unused icon in MARIO and empty slots next to it
	STA $0EFD ;  | (replaces MARIO with the icons)
	STA $0EFE ;  |
	STA $0EFF ;  |
	STA $0F00 ; /
	LDX #$FC
	LDA $0DBE
	CMP #$01
	BEQ Four
	CMP #$02
	BEQ Three
	CMP #$03
	BEQ Two
	CMP #$04
	BEQ One
	CMP #$05
	BEQ Return
	STX $0EFC
Four:
	STX $0EFD
Three:
	STX $0EFE
Two:
	STX $0EFF
One:
	STX $0F00
Return:
	PLX
	LDA $0DBE
	INC A 
    RTL

%RATS_end(0)